/*
   复制页面接口
 */

let fs = require("fs");
let config = require("../util/config");
let poFactory = require("./po/poFactory.js");
let dateFormat = require("dateformat");
var request = require("request");
var Lion = require("@dp/lion-client");
var qs = require("qs");
let str = require("../src/webUtil/str.js");
var ConfigJSON = require("../src/webUtil/ConfigJSON.js");
module.exports = function *(next){
    let req = this.request;
    let params = req.body;
    let pageStore = require(`../plugin/${config.storePlugin}`)("page");
    if(!params.id){
      this.throw(200,{
        code:500,
        msg:"id不能为空"
      });
    } else {
      let pagePo = yield poFactory(['name','topicId','title','endTime','platform','bu','author','share','config','status','templateId','publishStatus','onLine','publishUser','useCentralCity'],params);
      let pages = yield pageStore.search({id:params.id})
      let page = pages&&pages[0]
      //let pagePo = yield poFactory(['name','title','endTime','platform','bu','share','config','templateId'],page);
      //清理config
      var configStr = str.decode(page.config)
      var ModelList = JSON.parse(configStr || '[]')
      ConfigJSON.clearModelListData(ModelList)
      pagePo['config'] = str.encode(JSON.stringify(ModelList))
      pagePo['status'] = 1
      pagePo['endTime'] = dateFormat(pagePo['endTime'],'yyyy-mm-dd') + ' 23:59:59';
      pagePo['publishStatus'] = 1
      pagePo['onLine'] = 1
      var pageDto = {
        name:pagePo.name,
        title:pagePo.title,
        templateId:pagePo.templateId || 1,
        destPlatform:pagePo.platform,
        author:pagePo.author,
        pageDesc:'',
        status:-2
      }
      pagePo['topicId'] = yield new Promise(function(resolve,reject){
        Lion.getProperty("uno-web.topicIdServerUrl" , '').then(function(value){
          request(`${value}?`+qs.stringify(pageDto), function(error, response, body) {
            try{
              var result = JSON.parse(body || '{}');
              resolve(result.result);
            }catch (err){
              resolve();
            }
          });
        });
      })
      if(!pagePo['topicId']) {
        this.throw(200,{
          code:500,
          msg:"生成topicId异常"
        });
        return
      }
      pagePo.time = dateFormat(new Date(),'yyyy-mm-dd HH-MM-ss');
      pagePo.updateTime = dateFormat(new Date(),'yyyy-mm-dd HH-MM-ss');
      yield pageStore.insert(pagePo)
      let pageCmpMapStore = require(`../plugin/${config.storePlugin}`)("pageCmpMap");
      let pageCmpMaps = yield pageCmpMapStore.search({topicId:page.topicId,status:1})
      var pageCmpMap = pageCmpMaps&&pageCmpMaps[0]
      if(pageCmpMap) {
        yield pageCmpMapStore.insert({
          topicId:pagePo.topicId,
          cmpUniqueKeys:pageCmpMap.cmpUniqueKeys,
          status:1,
          time: dateFormat(new Date(),'yyyy-mm-dd HH-MM-ss')
        })
      }
      this.throw(200,{
        code:200,
        msg:"复制页面成功"
      });
    }
  };

