/*
   保存页面接口
 */

let fs = require("fs");
let config = require("../util/config");
let poFactory = require("./po/poFactory.js");
var qs = require("qs");
module.exports = function *(next){
    let req = this.request;
    let res = this.response;
    let params = req.query;
    let userinfo = {};
    //登录账号过滤
    if(config.userPlugin){
      yield require(`../plugin/${config.userPlugin}`).filter(req,res);
      userinfo = yield require(`../plugin/${config.userPlugin}`).get(req,res);
    }
    let pageStore = require(`../plugin/${config.storePlugin}`)("page");
    var pages = yield pageStore.search({
      id: params.id
    });
    var page = pages&&pages[0];
    if(!page || !page.id){
      this.throw(200,{
        code:500,
        msg:"页面Id不存在！params：" +JSON.stringify(params)
      });
      return
    }
    if (!userinfo || userinfo.login != page.author) {
      this.throw(200,{
        code:500,
        msg:`无权删除！仅${page.author}(创建人)可删除！`
      });
      return
    }
    yield pageStore.update({status:0},{
      id:params.id
    })
    this.throw(200,{
      code:200,
      msg:"删除页面成功！"
    });
  };

