/*
   获取页面详情
 */

let fs = require("fs");
let config = require("../util/config");
var Lion = require("@dp/lion-client");
module.exports = function *(next){
    let req = this.request;
    let topicId = req.query.topicId;
    if(!topicId){
      this.throw(200,{
        code:500,
        msg:"topicId不能为空"
      });
      return ;
    };
    let pageStore = require(`../plugin/${config.storePlugin}`)("page");
    let pages = yield pageStore.search({
      topicId:topicId
    });
    let pageCmpMapStore = require(`../plugin/${config.storePlugin}`)("pageCmpMap");
    let pageCmpMaps = yield pageCmpMapStore.search({
      topicId:topicId,
      status:1
    });
    var previewOrigin = null;
    let page = pages&&pages[0] || {}
    if(page.platform == 1){
      previewOrigin = yield Lion.getProperty("uno-web.previewOrigin" , '');
    }else{
      previewOrigin = yield Lion.getProperty("uno-web.previewMtOrigin" , '');
    }
    this.throw(200,{
      code:200,
      data:{
        name: page.name,
        topicId: page.topicId,
        config: page.config,
        versionConfig: page.versionConfig,
        platform: page.platform,
        cmpListStr: pageCmpMaps&&pageCmpMaps[0]&&pageCmpMaps[0].cmpUniqueKeys,
        publishStatus: page.publishStatus,
        previewOrigin: previewOrigin
      }
    });
  };


