/*
   获取页面列表接口
 */

let fs = require("fs");
let config = require("../util/config");
let pagePublishStatusText = require("./enums/pagePublishStatusText");
let platformText = require("./enums/platformText");
let pageStatusText = require("./enums/pageStatusText");
let pageStatus = require("./enums/pageStatus");
let buText = require("./enums/buText");
let dateFormat = require("dateformat");
module.exports = function *(next){
    let req = this.request;
    let pageIndex = req.query.pageIndex;
    let isSuperManager = req.query.isSuperManager;
    let bu = req.query.bu;
    let name = req.query.name;
    let login = req.query.login;
    let status = req.query.status;
    let publishStatus = req.query.publishStatus;
    let pageSize = req.query.pageSize || 20;
    let cmpUniqueKey = req.query.cmpUniqueKey;
    let pageTopicIds = []
    console.log(JSON.stringify(req.query))
    if (cmpUniqueKey) {
      let pageCmpMapStore = require(`../plugin/${config.storePlugin}`)("pageCmpMap");
      let pageCmpMaps = yield pageCmpMapStore.search({status:1},undefined,undefined,undefined,{cmpUniqueKeys:cmpUniqueKey})
      pageTopicIds = pageCmpMaps&&pageCmpMaps.map(page=> {return page.topicId})
    }
    let offset = 0;
    if(pageIndex){
      offset = (pageIndex - 1) * pageSize;
    }
    let pageStore = require(`../plugin/${config.storePlugin}`)("page");
    var whereEqual = {}
    var whereIn = {}
    if (cmpUniqueKey) {
      if(pageTopicIds && pageTopicIds.length > 0){
        whereIn['topicId'] = pageTopicIds
      } else {
        this.throw(200,{
          code:200,
          data:{
            pageInfo: {
              pageIndex: pageIndex,
              count: 0,
              pageSize: pageSize
            },
            pageList: []
          }
        });
        return
      }
    }
    if (status) {
      whereEqual['status'] = status
    }else {
      whereIn['status'] = [pageStatus.end,pageStatus.init,pageStatus.process]
    }
    if (bu && bu != 0) {
      whereEqual['bu'] = bu
    }
    if(login && login.length > 0) {
      whereEqual['author'] = login
    }
    if(publishStatus) {
      whereEqual['publishStatus'] = publishStatus
    }
    var pages = yield pageStore.search(whereEqual,whereIn);
    pages = pages || []
    if(name && name.length > 0) {
      pages = pages.filter(item => {
        if(item.name&&item.name.indexOf(name) > -1){
          return true
        }
        return false
      })
    }
    this.throw(200,{
      code:200,
      data:{
        pageInfo: {
          pageIndex: pageIndex,
          count: pages.length,
          pageSize: pageSize
        },
        pageList: pages.slice(offset, offset+pageSize).map(item => {
          return {
            id: item.id,
            author: item.author,
            platform:item.platform,
            useCentralCity:item.useCentralCity,
            platformText: platformText[item.platform],
            publishStatusText: pagePublishStatusText[item.publishStatus],
            buText: buText[item.bu] || '未知',
            publishStatus: item.publishStatus,
            statusText: pageStatusText[item.status],
            endTime: dateFormat(item.endTime, 'yyyy-mm-dd HH:MM'),
            time: dateFormat(item.time, 'yyyy-mm-dd HH:MM'),
            title: item.title,
            share: item.share,
            updateTime: dateFormat(item.updateTime, 'yyyy-mm-dd HH:MM'),
            topicId: item.topicId,
            name: item.name,
            onLine: item.onLine,
            end: dateFormat(item.endTime, 'yyyy-mm-dd') < dateFormat(new Date(), 'yyyy-mm-dd') ? true : false
          }
        })
      }
    });
  };


