/*
   发布页面接口
 */

let fs = require("fs");
let config = require("../util/config");
var qs = require("qs");
var DaXiang = require("../DaXiang.js")
module.exports = function *(next){
    let req = this.request;
    let topicId = req.query.pageId;
    let status = req.query.status;
    let pageStore = require(`../plugin/${config.storePlugin}`)("page");
    if (!topicId || !status) {
      this.throw({
        code:500,
        msg:`发布回调失败！ pageId 或 status 为空！ pageId-${topicId}   status-${status}`
      });
      return
    }
    if (topicId) {
      let pages = yield pageStore.search({topicId:topicId})
      let page = (pages && pages[0]) || {}
      var updateObj = {
        publishStatus: status,
        publishUser: ''
      }
      if(page.status === 1) {
        updateObj.status = 2
      }
      yield pageStore.update(updateObj,{
        topicId:topicId
      })
      let publishUser = page.publishUser
      let author = page.author
      let msgMap = {
        2: '成功',
        4: '失败，请使用其他操作->管理员发布功能，便于管理员跟进！'
      }
      let message = `通知：你好！${publishUser || '某开发使用CI'}发布活动${topicId}${msgMap[status]}`
      yield new Promise(function(resolve,reject){
        DaXiang(req.query.source).send(
          message
        ).to([author,publishUser]).then(function(res){
          resolve(res.data && res.data.total)
        });
      })
    }
    this.throw({
      code:100,
      msg:"发布回调成功!"
    });
  };

