/*
   保存组件接口
 */

let fs = require("fs");
let config = require("../util/config");
let poFactory = require("./po/poFactory.js");
var UUID = require('uuid');
module.exports = function *(next){
    let req = this.request;
    let params = req.body;
    let componentStore = require(`../plugin/${config.storePlugin}`)("component");
    let componentPo = yield poFactory(['cName','config','platform','buCodes','type','previewImg','status','uniqueKey','businessKeys'],params);
    if(componentPo.buCodes){
      componentPo.buCodes = componentPo.buCodes.toString();
    }
    if(!componentPo.uniqueKey){
      componentPo.uniqueKey = UUID.v1();
      componentPo.time = +new Date();
      yield componentStore.insert(componentPo)
    }else {
      let result = yield componentStore.search({uniqueKey:componentPo.uniqueKey});
      if(result&&result.length>0){
        yield componentStore.update(componentPo,{
          uniqueKey:componentPo.uniqueKey
        })
      }else {
        componentPo.time = +new Date();
        yield componentStore.insert(componentPo)
      }
    }
    this.throw({
      code:100,
      msg:"保存组件信息成功"
    });
  }

