/*
   保存页面接口
 */

let fs = require("fs");
let config = require("../util/config");
let poFactory = require("./po/poFactory.js");
let dateFormat = require("dateformat");
var request = require("request");
var Lion = require("@dp/lion-client");
var qs = require("qs");
let str = require("../src/webUtil/str.js");
var exec = require('child_process').exec;
var npm = require('npm');
let semver = require('semver');
var getVersion = function *(pageName){
  let versionKey = yield Lion.getProperty('uno-preview-web.versionKey','')
  return yield new Promise(function(resolve,reject){
    // var dir = `npm view ${pageName}  --registry=http://r.npm.sankuai.com`
    // exec(dir, function(err, stdout, stderr) {
    //   if(err){
    //     resolve(null)
    //   }else {
    //     var str = stdout.replace(/ /g,'')

    //     var matchList = str.match(/version:['|"]((\d+.\d+.\d+)(-[a-z]+.\d+)?)['|"]/)
    //     resolve(matchList&&(matchList[1]))
    //   }
    // });


    npm.load({}, function(){

      npm.commands.view([pageName, "versions"], function(err, data){
          if(err){
              Promise.reject(null);
          }
          let componentVersion = null;
          let componentPrereleaseVersion = null;
          Object.keys(data || []).forEach((c)=>{
              let targetVersion = data[c].versions || [];
              targetVersion.forEach((tv)=>{
                  let prerelease = semver.prerelease(tv);
                  if(prerelease){
                      if(versionKey && versionKey != "" && prerelease[0] == versionKey){
                          componentPrereleaseVersion = tv;
                      }
                  }else{
                      componentVersion = tv;
                  }
              })
          })
          let version = (versionKey && versionKey != "") ? componentPrereleaseVersion : componentVersion;
          resolve(version);
      });

    })



  });
}
var getVersionObj = function *(moduleList,obj){
  for(var i =0;i<moduleList.length;i++){
    var module = moduleList[i];
    if(!obj[module.name]){
      obj[module.name] = yield getVersion(module.name)
    }
    if(module.slots){
      for(var j =0;j<module.slots.length;j++){
        var slot = module.slots[j]
        if(slot.cards){
          yield getVersionObj(slot.cards,obj)
        }
      }
    }
  }
}
var mergerVersionConfig = function *(old,cur){

  if(!old) old=[];
  for(var i =0;i<Object.keys(cur).length;i++){
    var key = Object.keys(cur)[i]
    cur[key] = old[key] || cur[key]
  }
}
module.exports = function *(next){
    let req = this.request;
    let params = req.body;
    let pageStore = require(`../plugin/${config.storePlugin}`)("page");
    let pagePo = yield poFactory(['versionConfig','name','topicId','title','endTime','platform','bu','author','share','config','status','templateId','publishStatus','onLine','publishUser','useCentralCity','source'],params);
    if (pagePo.endTime) {
        pagePo.endTime = dateFormat(pagePo.endTime, 'yyyy-mm-dd') + ' 23:59:59';
    }
    if (pagePo.config ) {
        var module = JSON.parse(str.decode(pagePo.config)||'[]')
      var newVersionConfig = {}
      yield getVersionObj(module,newVersionConfig)
      yield mergerVersionConfig(JSON.parse(pagePo.versionConfig||'{}'),newVersionConfig)
      pagePo.versionConfig = JSON.stringify(newVersionConfig)
    }
    if (pagePo.config ) {
      var module = JSON.parse(str.decode(pagePo.config)||'[]')
      var newVersionConfig = {}
      yield getVersionObj(module,newVersionConfig)
      yield mergerVersionConfig(JSON.parse(pagePo.versionConfig||'{}'),newVersionConfig)
      pagePo.versionConfig = JSON.stringify(newVersionConfig)
    }
    if (params.id && params.topicId) {
      delete pagePo.bu
      yield pageStore.update(pagePo,{
        id:params.id
      })
      var pageDto = {
        topicId:params.topicId,
        name:pagePo.name,
        title:pagePo.title,
        templateId:pagePo.templateId || 1,
        destPlatform:pagePo.platform,
        author:pagePo.author,
        pageDesc:'',
        status:-2
      }
      //todo  更新彩虹 页面基本信息   需要kun.zhang接口支持后  去掉注释
      //yield new Promise(function(resolve,reject){
      //  Lion.getProperty("uno-web.topicIdServerUrl" , '').then(function(value){
      //    request(`${value}?`+qs.stringify(pageDto), function(error, response, body) {
      //        console.warn('=====update=====');
      //        console.warn(body);
      //        resolve(body);
      //    });
      //  });
      //})
    } else if (params.topicId) {
      delete pagePo.bu
      yield pageStore.update(pagePo,{
        topicId:params.topicId
      })
      // 更新页面使用的组件列表
      var cmpListStr = params.cmpListStr
      let pageCmpMapStore = require(`../plugin/${config.storePlugin}`)("pageCmpMap");
      let pageCmpMaps = yield pageCmpMapStore.search({topicId:params.topicId,status:1})
      if(pageCmpMaps&&pageCmpMaps.length>1){
        //todo 异常 cat
      }else {
        var pageCmpMap = pageCmpMaps&&pageCmpMaps[0]
        if(pageCmpMap&&pageCmpMap.cmpUniqueKeys != cmpListStr) {
          yield pageCmpMapStore.update({status:0},{id:pageCmpMap.id})
        }
        var dbCmpUniqueKeys = pageCmpMap&&pageCmpMap.cmpUniqueKeys
        if(cmpListStr&&cmpListStr.length>0&&cmpListStr!=dbCmpUniqueKeys){
          yield pageCmpMapStore.insert({
            topicId:params.topicId,
            cmpUniqueKeys:cmpListStr,
            status:1,
            time: dateFormat(new Date(),'yyyy-mm-dd HH-MM-ss')
          })
        }
      }
    }else {
      var that = this;
      var pageDto = {
        name:pagePo.name,
        title:pagePo.title,
        templateId:pagePo.templateId || 1,
        destPlatform:pagePo.platform,
        author:pagePo.author,
        pageDesc:'',
        status:-2
      }
      yield new Promise(function(resolve,reject){
        Lion.getProperty("uno-web.topicIdServerUrl" , '').then(function(value){
          if(!value || value.length <1){
            reject({msg:'调用lion服务失败，获取uno-web.topicIdServerUrl失败！'})
          }
          request(`${value}?`+qs.stringify(pageDto), function(error, response, body) {
            if(error){
              reject({msg:error.message})
            } else {
              var result = JSON.parse(body);
              resolve(result);
            }
          });
        });
      }).then(function(result){
        if(result.code==100){
          pagePo.topicId = result.result;
        }else {
          that.throw(500,{
            code:500,
            msg:"生成topicId失败,失败code"+result.code
          })
        }
      },function(data){
        that.throw(500,{
          code:500,
          msg:"生成topicId失败"
        });
      });
      if(!pagePo.topicId){
         return
      }
      let templateStore = require(`../plugin/${config.storePlugin}`)("template");
      let tems = yield templateStore.search({id:pagePo.templateId});
      pagePo.config = tems&&tems[0]&&tems[0].config; //默认为1
      pagePo.time = dateFormat(new Date(),'yyyy-mm-dd HH-MM-ss');
      pagePo.updateTime = dateFormat(new Date(),'yyyy-mm-dd HH-MM-ss');
      pagePo.status = 1; //默认为1
      pagePo.publishStatus = 1; //默认为1
      pagePo.onLine = 1; //默认为1
      yield pageStore.insert(pagePo)
    }
    this.throw(200,{
      code:200,
      data:pagePo.topicId,
      msg:"保存页面信息成功"
    });
  };

