'use strict';

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

var _ColLabel = require('./components/ColLabel.vue');

var _ColLabel2 = _interopRequireDefault(_ColLabel);

var _FormInput = require('./components/FormInput.vue');

var _FormInput2 = _interopRequireDefault(_FormInput);

var _FormTextArea = require('./components/FormTextArea.vue');

var _FormTextArea2 = _interopRequireDefault(_FormTextArea);

var _FormDate = require('./components/FormDate.vue');

var _FormDate2 = _interopRequireDefault(_FormDate);

var _FormDateTime = require('./components/FormDateTime.vue');

var _FormDateTime2 = _interopRequireDefault(_FormDateTime);

var _FormTime = require('./components/FormTime.vue');

var _FormTime2 = _interopRequireDefault(_FormTime);

var _FormUpload = require('./components/FormUpload.vue');

var _FormUpload2 = _interopRequireDefault(_FormUpload);

var _FormCheckBox = require('./components/FormCheckBox.vue');

var _FormCheckBox2 = _interopRequireDefault(_FormCheckBox);

var _FormReadText = require('./components/FormReadText.vue');

var _FormReadText2 = _interopRequireDefault(_FormReadText);

var _FormSelect = require('./components/FormSelect.vue');

var _FormSelect2 = _interopRequireDefault(_FormSelect);

var _FormColor = require('./components/FormColor.vue');

var _FormColor2 = _interopRequireDefault(_FormColor);

var _FormSwitch = require('./components/FormSwitch.vue');

var _FormSwitch2 = _interopRequireDefault(_FormSwitch);

var _ComponentsSelect = require('./specialComponents/ComponentsSelect.vue');

var _ComponentsSelect2 = _interopRequireDefault(_ComponentsSelect);

var _ComponentSelect = require('./specialComponents/ComponentSelect.vue');

var _ComponentSelect2 = _interopRequireDefault(_ComponentSelect);

var _CityIdSelect = require('./specialComponents/CityIdSelect.vue');

var _CityIdSelect2 = _interopRequireDefault(_CityIdSelect);

var _CityIdsSelect = require('./specialComponents/CityIdsSelect.vue');

var _CityIdsSelect2 = _interopRequireDefault(_CityIdsSelect);

var _CreateItemId = require('./specialComponents/CreateItemId.vue');

var _CreateItemId2 = _interopRequireDefault(_CreateItemId);

var _CouponId = require('./specialComponents/CouponId.vue');

var _CouponId2 = _interopRequireDefault(_CouponId);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_vue2.default.component('render-cmp', {
  render: function render(createElement) {
    var that = this;
    return createElement(this.name, {
      props: {
        onChange: function onChange(v) {
          that.onChange(v, that.objPath, that.keyStr);
        },
        tip: that.obj.description,
        label: that.obj.title,
        propsValue: that.obj.consequence,
        valueIsObj: that.obj.format == 'cityObjs' || that.obj.format == 'cityObj',
        required: that.required,
        breed: that.obj.breed,
        width: 360,
        optionList: that.obj.optionList
      }
    });
  },
  data: function data() {
    return {
      multiple: false
    };
  },

  computed: {
    name: function name() {
      if (!this.obj) {
        return '';
      }
      if (this.obj.media && this.obj.media.type && this.obj.media.type.indexOf('image') > -1) {
        return 'formUpload';
      } else if (this.obj.format === 'date-time') {
        return 'formDateTime';
      } else if (this.obj.format === 'time') {
        return 'formTime';
      } else if (this.obj.format === 'color' || this.obj.type === 'color') {
        return 'formColor';
      } else if (this.obj.optionList && this.obj.optionList.length > 0) {
        return 'formSelect';
      } else if (this.obj.media && this.obj.media.type && this.obj.media.type.indexOf('text') > -1) {
        return 'formTextArea';
      } else if (this.obj.format === 'components') {
        return 'componentsSelect';
      } else if (this.obj.format === 'component') {
        return 'componentSelect';
      } else if (this.obj.format === 'cityIds' || this.obj.format === 'cityObjs') {
        return 'cityIdsSelect';
      } else if (this.obj.format === 'cityId' || this.obj.format === 'cityObj') {
        return 'cityIdSelect';
      } else if (this.obj.type === 'boolean') {
        return 'formSwitch';
      } else if (this.obj.format === 'tab') {
        return 'createItemId';
      } else if (this.obj.format === 'event') {
        return 'couponId';
      }
      return 'formInput';
    }
  },
  props: {
    obj: Object,
    onChange: Function,
    objPath: String,
    keyStr: String,
    required: Boolean
  },
  components: {
    colLabel: _ColLabel2.default,
    formInput: _FormInput2.default,
    formTextArea: _FormTextArea2.default,
    formDate: _FormDate2.default,
    formUpload: _FormUpload2.default,
    formCheckBox: _FormCheckBox2.default,
    formReadText: _FormReadText2.default,
    formTime: _FormTime2.default,
    formSelect: _FormSelect2.default,
    formSwitch: _FormSwitch2.default,
    formColor: _FormColor2.default,
    componentsSelect: _ComponentsSelect2.default,
    componentSelect: _ComponentSelect2.default,
    cityIdsSelect: _CityIdsSelect2.default,
    cityIdSelect: _CityIdSelect2.default,
    createItemId: _CreateItemId2.default,
    couponId: _CouponId2.default,
    formDateTime: _FormDateTime2.default
  }
});