'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

require('./RenderCmp.js');

var _CmpTree = require('./pages/CmpTree.vue');

var _CmpTree2 = _interopRequireDefault(_CmpTree);

var _FormTree = require('./pages/FormTree.vue');

var _FormTree2 = _interopRequireDefault(_FormTree);

var _elementUi = require('element-ui');

var _elementUi2 = _interopRequireDefault(_elementUi);

require('element-ui/lib/theme-default/index.css');

require('./less/main.less');

var _PageDetail = require('./pages/PageDetail');

var _PageDetail2 = _interopRequireDefault(_PageDetail);

var _index = require('./store/index.js');

var _index2 = _interopRequireDefault(_index);

var _str = require('./webUtil/str');

var _str2 = _interopRequireDefault(_str);

var _unoConfig = require('./webUtil/unoConfig');

var _unoConfig2 = _interopRequireDefault(_unoConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_vue2.default.component('cmp-tree', _CmpTree2.default);
_vue2.default.component('form-tree', _FormTree2.default);

_vue2.default.use(_elementUi2.default);

module.exports = {
  createPage: function createPage(page) {
    return new _promise2.default(function (resolve, reject) {
      _index2.default.dispatch('savePage', {
        params: (0, _assign2.default)({
          source: _unoConfig2.default.source,
          author: _unoConfig2.default.userInfo && _unoConfig2.default.userInfo.login,
          loginType: _unoConfig2.default.userInfo && _unoConfig2.default.userInfo.loginType
        }, page),
        cb: function cb(topicId) {
          resolve(topicId);
        },
        err: function err(msg) {
          reject(msg);
        }
      });
    });
  },
  init: function init(businessKey, userInfo, env) {
    _unoConfig2.default.env = env;
    _unoConfig2.default.userInfo = userInfo;
    _unoConfig2.default.source = businessKey;
  },
  render: function render(node, uiOptions, page) {

    _index2.default.commit('setViewConfig', uiOptions.interface);

    _index2.default.commit('setPreviewConfig', uiOptions.preview);

    _index2.default.commit('setPageTopicId', page.topicId);

    _index2.default.commit('setPageDetail', page);

    _index2.default.commit('setPageConfig', _str2.default.decode(page.config));

    _index2.default.commit('setVersionConfig', _str2.default.decode(page.versionConfig));

    _index2.default.commit('setPagePlatform', page.platform);

    _index2.default.commit('setPageName', page.name);

    _index2.default.commit('setPublishStatus', page.publishStatus);

    _index2.default.commit('setNeedQueryPageDetail', false);

    _index2.default.dispatch('getEnums');

    _vue2.default.component('page-detail', _PageDetail2.default);

    new _vue2.default({
      store: _index2.default,
      el: node
    });
  },
  savePage: function savePage(page) {
    return new _promise2.default(function (resolve, reject) {
      _index2.default.dispatch('savePage', {
        params: page,
        cb: function cb(topicId) {
          resolve(topicId);
        },
        err: function err(msg) {
          reject(msg);
        }
      });
    });
  },
  saveConfig: function saveConfig() {
    return new _promise2.default(function (resolve, reject) {
      var pageDetail = {
        topicId: _index2.default.state.page.topicId,
        config: (0, _stringify2.default)(_index2.default.state.page.config),
        versionConfig: (0, _stringify2.default)(_index2.default.state.page.versionConfig)
      };
      _index2.default.dispatch('savePage', {
        params: pageDetail,
        cb: function cb(topicId) {
          resolve(topicId);
        },
        err: function err(msg) {
          reject(msg);
        }
      });
      var optList = JSON.parse((0, _stringify2.default)(_index2.default.state.page.optList));
      if (optList && optList.length > 0) {
        _index2.default.commit('initOptList');
        _index2.default.dispatch('executeOptList', {
          params: optList,
          pageId: _index2.default.state.page.topicId
        });
      }
    });
  },
  publish: function publish() {
    return new _promise2.default(function (resolve, reject) {
      var pageDetail = {
        topicId: _index2.default.state.page.topicId,
        config: (0, _stringify2.default)(_index2.default.state.page.config),
        versionConfig: (0, _stringify2.default)(_index2.default.state.page.versionConfig),
        publishStatus: 3,
        publishUser: _unoConfig2.default.userInfo.login
      };
      _index2.default.dispatch('savePage', {
        params: pageDetail,
        cb: function cb(topicId) {
          _index2.default.dispatch('publish', {
            params: {
              pageId: _index2.default.state.page.topicId,
              source: _index2.default.state.source
            },
            cb: function cb() {
              resolve();
            },
            err: function err(msg) {
              reject(msg);
            }
          });
        },
        err: function err(msg) {
          reject(msg);
        }
      });
      var optList = JSON.parse((0, _stringify2.default)(_index2.default.state.page.optList));
      if (optList && optList.length > 0) {
        _index2.default.commit('initOptList');
        _index2.default.dispatch('executeOptList', {
          params: optList,
          pageId: _index2.default.state.page.topicId
        });
      }
    });
  },
  allVersions: function allVersions() {},
  rollback: function rollback() {},
  checkStatus: function checkStatus() {},
  offline: function offline() {
    return new _promise2.default(function (resolve, reject) {
      var pageDetail = {
        topicId: _index2.default.state.page.topicId,
        onLine: 0,
        publishStatus: 3,
        publishUser: _unoConfig2.default.userInfo.login
      };
      _index2.default.dispatch('savePage', {
        params: pageDetail,
        cb: function cb(topicId) {
          _index2.default.dispatch('publish', {
            params: {
              pageId: _index2.default.state.page.topicId,
              source: _index2.default.state.source
            },
            cb: function cb() {
              resolve();
            },
            err: function err(msg) {
              reject(msg);
            }
          });
        },
        err: function err(msg) {
          reject(msg);
        }
      });
    });
  }
};