'use strict';

var _request = require('../webUtil/request');

var _request2 = _interopRequireDefault(_request);

var _unoConfig = require('../webUtil/unoConfig');

var _unoConfig2 = _interopRequireDefault(_unoConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = {
  state: {
    'modelType': [],
    'cityList': [],
    'platformList': [{ 'name': '点评', id: '1' }, { 'name': '美团', id: '2' }],
    'logoMap': {
      'rainbow': {
        name: '彩虹营销系统', nameWidth: 4, logo: "http://rainbow.dper.com/images/logo_tiny.png",
        defaultTopMenu: 1,
        topMenu: [{
          'name': '首页',
          'url': _unoConfig2.default.env == "production" ? 'http://rainbow.dper.com/#/home' : 'http://rainbow.51ping.com/#/home'
        }, {
          'name': '活动管理',
          'url': 'Not'
        }, {
          'name': '提报',
          'url': _unoConfig2.default.env == "production" ? 'http://rainbow.dper.com/#/activity/multiEnrollList' : 'http://rainbow.51ping.com/#/activity/multiEnrollList'
        }, {
          'name': '投放',
          'url': _unoConfig2.default.env == "production" ? 'http://oppkit.dper.com/documents/list.html' : 'http://oppkit.51ping.com/documents/list.html'
        }, {
          'name': '预算',
          'url': _unoConfig2.default.env == "production" ? "http://rainbow.dper.com/#/budget/apply" : "http://rainbow.51ping.com/#/budget/apply"
        }, {
          'name': '权限',
          'url': _unoConfig2.default.env == "production" ? "http://rainbow.dper.com/#/auth/manage" : "http://rainbow.51ping.com/#/auth/manage"
        }],
        defaultLeftMenu: 0,
        leftMenu: [{
          'name': '专题活动',
          'url': 'Not'
        }, {
          'name': '领券活动',
          'url': _unoConfig2.default.env == "production" ? 'http://rainbow.dper.com/#/toast/coupon' : 'http://rainbow.51ping.com/#/toast/coupon'
        }, {
          'name': '抽奖活动',
          'url': _unoConfig2.default.env == "production" ? 'http://rainbow.dper.com/#/toast/draw' : 'http://rainbow.51ping.com/#/toast/draw'
        }, {
          'name': '购买分享红包',
          'url': _unoConfig2.default.env == "production" ? 'http://rainbow.dper.com/#/toast/envelope' : 'http://rainbow.51ping.com/#/toast/envelope'
        }, {
          'name': '超级人品团',
          'url': _unoConfig2.default.env == "production" ? 'http://rainbow.dper.com/#/toast/group1' : 'http://rainbow.51ping.com/#/toast/group1'
        }, {
          'name': '天天免费',
          'url': _unoConfig2.default.env == "production" ? 'http://rainbow.dper.com/#/toast/group2' : 'http://rainbow.51ping.com/#/toast/group2'
        }, {
          'name': '亲子拼团',
          'url': _unoConfig2.default.env == "production" ? 'http://rainbow.dper.com/#/toast/group3' : 'http://rainbow.51ping.com/#/toast/group3'
        }, {
          'name': '团单拼团',
          'url': _unoConfig2.default.env == "production" ? 'http://rainbow.dper.com/#/toast/group4' : 'http://rainbow.51ping.com/#/toast/group4'
        }]
      },
      'uno': {
        name: 'UNO', nameWidth: 2
      }
    },
    'itemTypeMap': {
      'deal': 1,
      'content': 3,
      'shop': 2
    },
    'pagePublishStatusList': [{ 'label': '全部', 'key': undefined }, { 'label': '草稿', 'key': 1 }, { 'label': '发布中', 'key': 3 }, { 'label': '发布成功', 'key': 2 }, { 'label': '发布失败', 'key': 4 }],
    'pageStatusList': [{ 'label': '全部', 'key': undefined }, { 'label': '草稿', 'key': 1 }, { 'label': '进行中', 'key': 2 }, { 'label': '已过期', 'key': 3 }]
  },
  mutations: {
    setModelType: function setModelType(state, payload) {
      state.modelType = payload;
    },
    setCityList: function setCityList(state, payload) {
      state.cityList = payload;
    }
  },
  actions: {
    getEnums: function getEnums(context) {
      _request2.default.getModelType().then(function (json) {
        if (json && json.code === 200) {
          context.commit('setModelType', json && json.data);
        } else {
          context.commit('error', json && json.msg);
        }
      });
      setTimeout(function () {
        _request2.default.cityList().then(function (json) {
          if (json && json.code === 200) {
            context.commit('setCityList', json && json.data);
          } else {
            context.commit('error', json && json.msg);
          }
        });
      }, 5000);
    }
  },
  getters: {}
};