'use strict';

var _vuex = require('vuex');

var _vuex2 = _interopRequireDefault(_vuex);

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

var _enums = require('./enums.js');

var _enums2 = _interopRequireDefault(_enums);

var _model = require('./model.js');

var _model2 = _interopRequireDefault(_model);

var _page = require('./page.js');

var _page2 = _interopRequireDefault(_page);

var _template = require('./template.js');

var _template2 = _interopRequireDefault(_template);

var _request = require('../webUtil/request');

var _request2 = _interopRequireDefault(_request);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_vue2.default.use(_vuex2.default);
var sourceMatchStr = location.search && location.search.match(/source=([\S]+)[\&]?/);
module.exports = new _vuex2.default.Store({
  modules: {
    enums: _enums2.default,
    model: _model2.default,
    page: _page2.default,
    template: _template2.default
  },
  state: {
    error: undefined,
    source: sourceMatchStr && sourceMatchStr[1]
  },
  mutations: {
    error: function error(state, payload) {
      state.error = payload;
    }
  },
  actions: {
    logout: function logout(context, payload) {
      _request2.default.logout(payload).then(function (json) {
        if (json && json.code === 200) {
          payload.cb && payload.cb();
        } else {
          context.commit('error', json && json.msg);
        }
      });
    }
  }
});