'use strict';

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _request = require('../webUtil/request');

var _request2 = _interopRequireDefault(_request);

var _unoConfig = require('../webUtil/unoConfig');

var _unoConfig2 = _interopRequireDefault(_unoConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = {
  state: {
    'list': {},
    'showList': {}
  },
  mutations: {
    setModelList: function setModelList(state, payload) {
      state.list = payload;
      state.showList = payload;
    },
    filterModelList: function filterModelList(state, payload) {
      if (!payload) {
        state.showList = JSON.parse((0, _stringify2.default)(state.list));
      } else {
        var obj = {};
        var keys = (0, _keys2.default)(state.showList) || [];
        keys.forEach(function (key) {
          var modelList = state.showList[key];
          var filterList = modelList && modelList.filter(function (model) {
            if (model.cName.indexOf(payload) > -1) {
              return true;
            }
            return false;
          });
          obj[key] = JSON.parse((0, _stringify2.default)(filterList));
        });
        state.showList = obj;
      }
    }
  },
  actions: {
    getModelList: function getModelList(context) {
      _request2.default.getComMap({ source: _unoConfig2.default.source }).then(function (json) {
        if (json && json.code === 200) {
          context.commit('setModelList', json && json.data);
        } else {
          context.commit('error', json && json.msg);
        }
      });
    }
  },
  getters: {}
};