'use strict';

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _request = require('../webUtil/request');

var _request2 = _interopRequireDefault(_request);

var _deepState = require('deep-state');

var _vue = require('vue');

var _vue2 = _interopRequireDefault(_vue);

var _ObjectFactory = require('./ObjectFactory');

var _ObjectFactory2 = _interopRequireDefault(_ObjectFactory);

var _ConfigJSON = require('../webUtil/ConfigJSON');

var _ConfigJSON2 = _interopRequireDefault(_ConfigJSON);

var _str = require('../webUtil/str');

var _str2 = _interopRequireDefault(_str);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = {
  state: {
    'viewConfig': {
      'head': true,
      'pageName': true,
      'cmpList': true,
      'position': true,
      'preview': true,
      'form': true
    },
    'previewConfig': {},
    'style': {
      "configTop": 133,
      "modelSpan": 3,
      "positionSpan": 3,
      "previewSpan": 6,
      "formSpan": 12,
      "pageMinWidth": 1180
    },
    'needQueryPageDetail': true,
    'config': [],
    'configStr': '',
    'versionConfig': '',
    'versionConfigObj': {},
    'optList': [],
    'cmpList': [],
    'pagePlatform': undefined,
    'topicId': undefined,
    'selectIndex': -1,
    'previewOrigin': null,
    'share': {},
    'query': {
      'name': undefined,
      'publishStatus': undefined,
      'status': undefined,
      'login': undefined
    },
    'pageList': [],
    'pageInfo': {
      'pageIndex': 1,
      'count': 0,
      'pageSize': 10
    },
    'pageDetail': {},
    'pageName': null,
    'publishStatus': null
  },
  mutations: {
    initOptList: function initOptList(state, payload) {
      state.optList = [];
    },
    setPageDetail: function setPageDetail(state, payload) {
      state.pageDetail = (0, _assign2.default)(_ObjectFactory2.default.emptyPageDetail(), payload);
      state.share = (0, _assign2.default)(_ObjectFactory2.default.emptyShare(), JSON.parse(payload.share || '{}'));
    },
    setPreviewConfig: function setPreviewConfig(state, payload) {
      _vue2.default.set(state, 'previewConfig', (0, _assign2.default)(state.previewConfig, payload));
    },
    setNeedQueryPageDetail: function setNeedQueryPageDetail(state, payload) {
      state.needQueryPageDetail = payload;
    },
    setViewConfig: function setViewConfig(state, payload) {
      _vue2.default.set(state, 'viewConfig', (0, _assign2.default)(state.viewConfig, payload));
      if (!state.viewConfig.head) {
        state.style.configTop -= 83;
      }
      if (!state.viewConfig.pageName) {
        state.style.configTop -= 50;
      }
      if (!state.viewConfig.cmpList) {
        state.style.pageMinWidth -= 200;
        state.style.positionSpan += state.style.modelSpan;
      }
      if (!state.viewConfig.position) {
        state.style.pageMinWidth -= 150;
        state.style.previewSpan += state.style.positionSpan;
      }
      if (!state.viewConfig.preview) {
        state.style.pageMinWidth -= 420;
        state.style.previewSpan += state.style.positionSpan;
      }
      if (!state.viewConfig.form) {
        state.style.pageMinWidth -= 410;
        state.style.previewSpan += state.style.formSpan;
      }
    },
    setPageTopicId: function setPageTopicId(state, payload) {
      state.topicId = payload;
    },
    setPreviewOrigin: function setPreviewOrigin(state, payload) {
      state.previewOrigin = payload;
    },
    setPageName: function setPageName(state, payload) {
      state.pageName = payload;
    },
    setPagePlatform: function setPagePlatform(state, payload) {
      state.pagePlatform = payload;
    },
    setCmpList: function setCmpList(state, payload) {
      state.cmpList = payload ? payload.split(',') : [];
    },
    setPageConfig: function setPageConfig(state, payload) {
      _vue2.default.set(state, 'configStr', payload);
      var list = JSON.parse(payload || '[]');
      if (list && list.length > 0) {
        _vue2.default.set(state, 'config', list);
        _vue2.default.set(state, 'selectIndex', 0);
      } else {
        state.config = [];
        state.selectIndex = -1;
      }
    },
    setVersionConfig: function setVersionConfig(state, payload) {
      _vue2.default.set(state, 'versionConfig', payload);
      var obj = JSON.parse(payload || '{}');
      _vue2.default.set(state, 'versionConfigObj', obj);
    },
    changeConfig: function changeConfig(state, payload) {
      console.warn(payload);
      _vue2.default.set(state.config[payload.objPath.split('.')[0]], 'showDefault', false);
      var obj = (0, _deepState.getPath)(state.config, payload.objPath) || {};
      _vue2.default.set(obj, payload.key, payload.value);
    },
    changeConfigDeleteList: function changeConfigDeleteList(state, payload) {
      var obj = (0, _deepState.getPath)(state.config, '' + payload.path) || {};
      obj.list.splice(payload.index, 1);
    },
    changeConfigAddList: function changeConfigAddList(state, payload) {
      var obj = (0, _deepState.getPath)(state.config, '' + payload.path) || {};
      var items = (0, _deepState.getPath)(state.config, payload.path + '.items') || {};
      var newItems = JSON.parse((0, _stringify2.default)(items));
      if (!obj.list || obj.list.length < 1) {
        _vue2.default.set(obj, 'list', [newItems]);
      } else {
        obj.list.splice(payload.index, 0, newItems);
      }
    },
    dragModel: function dragModel(state, payload) {
      var cmpIndex = parseInt(payload[0]);
      var index = parseInt(payload[1]);
      var obj = JSON.parse((0, _stringify2.default)(state.config[cmpIndex]));
      var cmp = state.cmpList[cmpIndex];
      state.config.splice(cmpIndex, 1);
      state.config.splice(index, 0, obj);
      state.cmpList.splice(cmpIndex, 1);
      state.cmpList.splice(index, 0, cmp);
      state.selectIndex = parseInt(index);
    },
    moveUp: function moveUp(state, payload) {
      var cmpIndex = parseInt(payload);
      var obj = JSON.parse((0, _stringify2.default)(state.config[cmpIndex]));
      var cmp = state.cmpList[cmpIndex];
      var targetIndex = cmpIndex - 1 >= 0 ? cmpIndex - 1 : 0;
      state.config.splice(cmpIndex, 1);
      state.config.splice(targetIndex, 0, obj);
      state.cmpList.splice(cmpIndex, 1);
      state.cmpList.splice(targetIndex, 0, cmp);
      state.selectIndex = parseInt(targetIndex);
    },
    moveDown: function moveDown(state, payload) {
      var cmpIndex = parseInt(payload);
      var obj = JSON.parse((0, _stringify2.default)(state.config[cmpIndex]));
      var cmp = state.cmpList[cmpIndex];
      var targetIndex = cmpIndex + 1 < state.cmpList.length ? cmpIndex + 1 : state.cmpList.length - 1;
      state.config.splice(cmpIndex, 1);
      state.config.splice(targetIndex, 0, obj);
      state.cmpList.splice(cmpIndex, 1);
      state.cmpList.splice(targetIndex, 0, cmp);
      state.selectIndex = parseInt(targetIndex);
    },
    addModel: function addModel(state, payload) {
      state.config.splice(++state.selectIndex, 0, payload.config);
      state.cmpList.splice(state.selectIndex, 0, payload.uniqueKey);
    },
    deleteModel: function deleteModel(state, payload) {
      var optList = _ConfigJSON2.default.getOptListAboutDeleteList([state.config[payload]]);
      optList = optList.concat(JSON.parse((0, _stringify2.default)(state.optList)));
      console.warn((0, _stringify2.default)(state.optList));
      _vue2.default.set(state, 'optList', optList);
      console.warn('deleteModel');
      console.warn((0, _stringify2.default)(optList));
      console.warn((0, _stringify2.default)(state.optList));
      if (payload > -1 && payload < state.config.length) {
        if (payload === state.config.length - 1) {
          state.selectIndex = parseInt(payload) - 1;
        } else {
          state.selectIndex = parseInt(payload);
        }
        state.config.splice(payload, 1);
        state.cmpList.splice(payload, 1);
      }
    },
    setSelectIndex: function setSelectIndex(state, payload) {
      console.warn('setSelectIndex');
      console.warn(payload);
      state.selectIndex = payload;
    },
    setPublishStatus: function setPublishStatus(state, payload) {
      state.publishStatus = payload;
    },
    newPage: function newPage(state) {
      state.pageDetail = _ObjectFactory2.default.emptyPageDetail();
      state.share = _ObjectFactory2.default.emptyShare();
      state.config = [];
    },
    setList: function setList(state, payload) {
      _vue2.default.set(state, 'pageList', payload.pageList);
      _vue2.default.set(state, 'pageInfo', payload.pageInfo);
    },
    deletePage: function deletePage(state, payload) {
      state.pageList.splice(payload, 1);
    },
    changePageValue: function changePageValue(state, payload) {
      (0, _deepState.setPath)(state, payload.path, payload.value);
    },
    updateConfigBox: function updateConfigBox(state) {
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      if (data.type == "remove") {
        var val = _ConfigJSON2.default.removeConfigBox(state.versionConfig, data.param);
        _vue2.default.set(state, 'versionConfig', val);
        var obj = JSON.parse(val || '{}');
        _vue2.default.set(state, 'versionConfigObj', obj);
      }
    }
  },
  actions: {
    getPageConfig: function getPageConfig(context, payload) {
      _request2.default.getPageConfigByTopicId(payload).then(function (json) {
        if (json && json.code === 200) {
          context.commit('setPageConfig', _str2.default.decode(json && json.data && json.data.config));
          context.commit('setVersionConfig', _str2.default.decode(json && json.data && json.data.versionConfig));
          context.commit('setCmpList', json && json.data && json.data.cmpListStr);
          context.commit('setPagePlatform', json && json.data && json.data.platform);
          context.commit('setPageTopicId', json && json.data && json.data.topicId);
          context.commit('setPageName', json && json.data && json.data.name);
          context.commit('setPublishStatus', json && json.data && json.data.publishStatus);
          context.commit('setPreviewOrigin', json && json.data && json.data.previewOrigin);
        } else {
          context.commit('error', json && json.msg);
        }
      });
    },
    getPageList: function getPageList(context, payload) {
      _request2.default.getPageList(payload).then(function (json) {
        if (json && json.code === 200) {
          context.commit('setList', json && json.data);
        } else {
          context.commit('error', json && json.msg);
        }
      });
    },
    clearPageList: function clearPageList(context, payload) {
      context.commit('setList', {
        pageInfo: context.state.pageInfo,
        pageList: []
      });
    },
    savePage: function savePage(context, payload) {
      if (payload.params.config) {
        payload.params.config = _str2.default.encode(payload.params.config);
      }
      _request2.default.savePage(payload.params).then(function (json) {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json.data);
        } else {
          payload.err && payload.err(json && json.msg);
          context.commit('error', json && json.msg);
        }
      });
    },
    deletePage: function deletePage(context, payload) {
      var params = {
        id: payload.page.id
      };
      _request2.default.deletePage(params).then(function (json) {
        if (json && json.code === 200) {
          context.commit('deletePage', payload.pageIndex);
          payload.cb && payload.cb();
        } else {
          payload.errorCb && payload.errorCb();
          context.commit('error', json && json.msg);
        }
      });
    },
    createItemId: function createItemId(context, payload) {
      _request2.default.createItemId(payload.params).then(function (json) {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json.data);
        } else {
          context.commit('error', json && json.msg);
        }
      });
    },
    savePageItemIdMap: function savePageItemIdMap(context, payload) {
      _request2.default.savePageItemIdMap(payload.params).then(function (json) {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json.data);
        } else {
          context.commit('error', json && json.msg);
        }
      });
    },
    publish: function publish(context, payload) {
      _request2.default.publish(payload.params).then(function (json) {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json);
        } else {
          context.commit('error', json && json.msg);
        }
      });
    },
    copyPage: function copyPage(context, payload) {
      _request2.default.copyPage(payload.params).then(function (json) {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json);
        } else {
          context.commit('error', json && json.msg);
        }
      });
    },
    sendMessage: function sendMessage(context, payload) {
      _request2.default.sendMessage(payload.params).then(function (json) {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json);
        } else {
          context.commit('error', json && json.msg);
        }
      });
    },
    executeOptList: function executeOptList(context, payload) {
      var optList = payload.params;
      if (optList && optList.length > 0) {
        var deleteItemOpts = optList.filter(function (item) {
          if (item.type === 'deleteItemId') {
            return true;
          }
          return false;
        });
        var itemIds = deleteItemOpts.map(function (item) {
          return item.data;
        });
        var params = {
          itemIds: itemIds && itemIds.toString(),
          pageId: payload.pageId
        };
        console.warn('deleteItemIds');
        console.warn((0, _stringify2.default)(params));
        _request2.default.deleteItemIds(params).then(function (json) {
          if (json && json.code === 200) {
            payload.cb && payload.cb(json);
          } else {
            context.commit('error', json && json.msg);
          }
        });
      }
    }
  },
  getters: {}
};