'use strict';

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _url = require('./url');

var _url2 = _interopRequireDefault(_url);

var _qs = require('qs');

var _qs2 = _interopRequireDefault(_qs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fetchRequest = function fetchRequest(url, options) {
  var opt = options;
  if (location.origin.indexOf('localhost') == -1 || location.origin.indexOf('8080') > -1) {
    opt = (0, _assign2.default)({ credentials: 'include' }, options);
  }
  return (0, _isomorphicFetch2.default)(url, opt).then(function (res) {
    return res.json();
  }).then(function (json) {
    return json.data;
  });
};
module.exports = {
  getComMap: function getComMap(params) {
    return fetchRequest(_url2.default.comMap + '?' + _qs2.default.stringify(params));
  },
  getModelType: function getModelType() {
    return fetchRequest(_url2.default.modelType);
  },
  savePage: function savePage(params) {
    return fetchRequest(_url2.default.savePage, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      body: _qs2.default.stringify(params)
    });
  },
  getPageList: function getPageList(params) {
    return fetchRequest(_url2.default.getPageList + '?' + _qs2.default.stringify(params));
  },
  getPageConfigByTopicId: function getPageConfigByTopicId(id) {
    return fetchRequest(_url2.default.getPageConfigByTopicId + '?topicId=' + id);
  },
  getTemplateList: function getTemplateList(params) {
    return fetchRequest(_url2.default.getTemplateList + '?' + _qs2.default.stringify(params));
  },
  createItemId: function createItemId(params) {
    return fetchRequest(_url2.default.createItemId + '?' + _qs2.default.stringify(params));
  },
  publish: function publish(params) {
    return fetchRequest(_url2.default.publishUrl + '?' + _qs2.default.stringify(params));
  },
  savePageItemIdMap: function savePageItemIdMap(params) {
    return fetchRequest(_url2.default.savePageItemIdMap + '?' + _qs2.default.stringify(params));
  },
  copyPage: function copyPage(params) {
    return fetchRequest(_url2.default.copyPage, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/x-www-form-urlencoded'
      },
      body: _qs2.default.stringify(params)
    });
  },
  deleteItemIds: function deleteItemIds(params) {
    return fetchRequest(_url2.default.deleteItemIds + '?' + _qs2.default.stringify(params));
  },
  sendMessage: function sendMessage(params) {
    return fetchRequest(_url2.default.sendMessage + '?' + _qs2.default.stringify(params));
  },
  logout: function logout() {
    return fetchRequest(_url2.default.logout);
  },
  deletePage: function deletePage(params) {
    return fetchRequest(_url2.default.deletePage + '?' + _qs2.default.stringify(params));
  },
  cityList: function cityList(params) {
    return fetchRequest(_url2.default.cityList + '?' + _qs2.default.stringify(params));
  }
};