var request = require("request");
var Lion = require("@dp/lion-client");
var cat=require("@dp/cat-client");
var qs=require("qs");
var path=require("path");
var Pigeon = require("@dp/pigeon-client");
var DaXiang = require("./DaXiang.js")
var exec = require('child_process').exec;
//pigeon start
Pigeon.init({
  appName: "uno-web"
});
Pigeon.start(path.resolve(__dirname, './config/pigeon.js'));
module.exports = function (app,koaBody) {
  
  var java = Pigeon.java;
  cat.init({
    appName:"uno-web"
  });
  app.get('/external/modelType',koaBody, function *(next){
    let req = this.request;
    let that = this;
    yield new Promise(function(resolve,reject){
      Lion.getProperty("virtual-components-web.modelType" , 'http://gmkt.activ.dianping.com/frontSource/loadByKey').then(function(value){
        request(`${value}?key=moduleType`, function(error, response, body) {
          if(error){
            that.throw(200,{code:500,msg:'获取类型列表失败！',err:error});
          } else {
            var result = JSON.parse(body);
            that.throw(200,{code:200,data:result.result});
          }
          resolve()
        });
      });
    });
  });

  app.get('/external/createItemId',koaBody, function *(next){
    let req = this.request;
    let that = this;
    var itemGenRequest = java('com.dianping.gmkt.event.datapools.api.request.ItemRegisterRequest', {
      source: java.int(4),
      platform: java.int(req.query.platform),
      contentType: java.int(req.query.itemType),
      operator: java.String(req.query.operator)
    })
    var result = yield Pigeon.services.dataManageService.invoke("itemRegister",itemGenRequest)
    if(result.itemID){
      that.throw(200,{code:200,data:result.itemID});
      var registerRequest = java('com.dianping.gmkt.event.datapools.api.request.ItemAttrRegisterRequest', {
        itemID: java.int(result.itemID),
        attriTypeKey: java.int(2),
        attriTypeValue: java.String(req.query.pageId),
        operator: java.String(req.query.operator)
      })
      var registerResult = yield Pigeon.services.itemAttributeService.invoke("register",registerRequest)
    } else {
      that.throw(200,{code:500,msg:`pigeon生成itemId失败 params:${JSON.stringify(req.query)} pigeonService:http://service.dianping.com/gmkt_event_datapools_service/dataManageService_0.0.1`});
    }
  });
  app.get('/external/deleteItemIds',koaBody, function *(next){
    let req = this.request;
    let that = this;
    let itemIds = req.query.itemIds || ''
    let itemList = itemIds.split(',')
    var result = []
    for (var i=0;i<itemList.length;i++) {
      var registerRequest = java('com.dianping.gmkt.event.datapools.api.request.ShutDownRequest', {
        type: java.int(1),
        pageID: java.int(req.query.pageId),
        itemID: java.int(itemList[i])
      })
      var registerResult = yield Pigeon.services.dataManageService.invoke("cancel",registerRequest)
      result.push(registerResult)
    }
    that.throw(200,{code:200,data:result});
  });

  app.get('/external/savePageItemIdMap',koaBody, function *(next){
    let req = this.request;
    let that = this;
    var registerRequest = java('com.dianping.gmkt.event.datapools.api.request.ItemAttrRegisterRequest', {
      itemID: java.int(req.query.itemId),
      attriTypeKey: java.int(2),
      attriTypeValue: java.String(req.query.pageId),
      operator: java.String(req.query.operator)
    })
    var registerResult = yield Pigeon.services.itemAttributeService.invoke("register",registerRequest)
    that.throw(200,{code:200,data:JSON.stringify(registerResult)});
  });

  app.get('/external/build',koaBody, function *(next){
    let req = this.request;
    let pageId = req.query.pageId;
    let that = this;
    var buildUrl = yield Lion.getProperty("uno-web.buildUrl" , "");
    if(!buildUrl || buildUrl.length < 1){
      that.throw(200,{code:500,msg:'Lion获取buildUrl异常!',data:pageId});
      return
    }
    var checkStatus = yield new Promise(function(resolve,reject){
      request(`${buildUrl}/job/${pageId}`, function(error, response, body) {
        resolve(response.statusCode)
      });
    });
    if (checkStatus !=200) {
      var jenKinsConfig = yield Lion.getProperty("gmkt-portal-web.rainbow.jenkins.config" , "");
      if(!jenKinsConfig){
        that.throw(200,{code:500,msg:'Lion获取jenKinsConfig异常!',data:pageId});
        return
      }
      var createStatus = yield new Promise(function(resolve,reject){
        request({
          url:`${buildUrl}/createItem?name=${pageId}`,
          method:'POST',
          headers: {
            'content-type': 'application/xml'
          },
          body:jenKinsConfig
        }, function(error, response, body) {
          resolve(response.statusCode)
        });
      });
      if(createStatus != 200) {
        that.throw(200,{code:500,msg:'创建jenKins发布项异常!httpStatus:'+createStatus,data:pageId});
        return
      }
    }
    var doWipeOutWorkspaceStatus = yield new Promise(function(resolve,reject){
      request({
        url:`${buildUrl}/job/${pageId}/doWipeOutWorkspace`,
        method:'POST',
        headers: {
          'content-type': 'application/x-www-form-urlencoded'
        }
      }, function(error, response, body) {
        resolve(response.statusCode)
      });
    });
    var publishStatus = yield new Promise(function(resolve,reject){
      request(`${buildUrl}/job/${pageId}/buildWithParameters?pageId=${pageId}`, function(error, response, body) {
        resolve(response.statusCode)
      });
    });
    if(publishStatus >= 400) {
      that.throw(200,{code:500,msg:`jenKins发布异常!${doWipeOutWorkspaceStatus}-${publishStatus}`,data:`清理工作区code：${doWipeOutWorkspaceStatus} 发布code:${publishStatus}`});
      return
    }
    that.throw(200,{code:200,msg:'发布中！',data:`清理工作区code：${doWipeOutWorkspaceStatus} 发布code:${publishStatus}`});
  });

  app.get('/external/sendMessage',koaBody, function *(next){
    let req = this.request;
    let that = this;
    let total = yield new Promise(function(resolve,reject){
      DaXiang(req.query.source).send(
        req.query.message
      ).to(req.query.login.split(',')).then(function(res){
        resolve(res.data && res.data.total)
      });
    })
    if(total > 0){
      that.throw(200,{code:200});
    } else {
      that.throw(200,{code:500,msg:`发送消息失败${res}`});
    }
  });
  app.get('/external/cityList',koaBody, function *(next){
    let req = this.request;
    let that = this;
    var hasCity = true;
    var index = 0;
    var res = []
    while (hasCity){
      var registerResult = yield Pigeon.services.cityInfoService.invoke("getInlandCityList",java.int(index),java.int(1000))
      registerResult.forEach(item=>{
        res.push({
          label:item.cityName,
          key:item.cityId
        })
      })
      index += 1000;
      if(registerResult.length<1000){
        hasCity = false
      }
    }
    that.throw(200,{code:200,data:res});
  });

  app.get('/external/getVersion',koaBody, function *(next){
    let req = this.request;
    let that = this;
    yield new Promise(function(resolve,reject){
      var dir = `npm view ${req.query.pageName}  --registry=http://r.npm.sankuai.com`
      exec(dir, function(err, stdout, stderr) {
        if(err){
          that.throw(200,{code:500,msg:'获取包版本失败！',err:err});
        }else {
          var str = stdout.replace(/ /g,'')
          var matchList = str.match(/version:['|"]((\d+.\d+.)\d+(-[a-z]+.\d+)?)['|"]/)
          that.throw(200,{code:200,data:{
            latest:matchList&&matchList[1],
            stable:matchList&&('^'+matchList[2]+'0')
          }});
        }
        resolve()
      });
    });
  });
};

