var Lion = require("@dp/lion-client");
var mysql = require("mysql");

const DB_URL = 'ds.uno-n1-write.jdbc.url';
const DB_USERNAME = 'ds.uno-n1-write.jdbc.username';
const DB_PASSWORD = 'ds.uno-n1-write.jdbc.password';

let dbConfig = {};

connect.init = function*() {
    var env = process.env.ENV || "beta";
    var jdbcUrl = yield Lion.httpGetProperty(DB_URL, env);
    var userName = yield Lion.httpGetProperty(DB_USERNAME, env);
    var password = yield Lion.httpGetProperty(DB_PASSWORD, env);
    var match = jdbcUrl.match(/mysql:\/\/([\d\.]+):(\d+)\/(\w+)\?/);
    if (match) {
        dbConfig.host = match[1];
        dbConfig.port = match[2];
        dbConfig.database = match[3];
    } else {
        throw (new Error("数据库配置解析出错"));
    }

    dbConfig.user = userName;
    dbConfig.password = password;
    return dbConfig;
};


function connect(table){
    return require("@dp/leoric-plugin-db")(Object.assign({
        table:table
    },dbConfig));
}

module.exports = connect;
