let config = require("config");
let host = config.get(`user.${process.env.ENV||"beta"}`);
let request = require("request");
let node_path = require("path");
let url=require("url");
let crypto=require("crypto");
const appkey = "uno";
const secret = "80008ef742ff17aa63269dbba0df0295";


function meituanBasicAuth(client_id, client_secret){
    const SPACE = ' ';
    const EOL   = '\n';
    return function(path, method, date ){
        method = method || 'GET';
        date = date || new Date();
        date    = date.toGMTString();
        method  = method.toUpperCase();
        path    = url.parse(path).pathname;
        // step1. GET /path
        var req           = [ method, path ].join(SPACE);
        // step2. step1 + GMT date string .
        var header        = [ req , date ].join(EOL);
        // step3. encrypt request
        var sha1          = crypto.createHmac('sha1', client_secret);
        // step4. base64ify.
        var token         = sha1.update(header).digest('base64');
        // xxx:xxx
        var signature     = [ client_id, token ].join(':');
        var authorization = [ 'MWS', signature ].join(SPACE);
        return {
            Date: date,
            Authorization: authorization
        };
    }
}

function getSid(req){
    return (req.body&&req.body.SID) ||  (req.ctx&&req.ctx.cookies&&req.ctx.cookies.get("SID")) || "";
}

let User = {
	filter:function* (req,res){
		let user = yield User.get(req);
        if(!user){
            res.redirect(`${host}/auth?service=http://${node_path.join(req.headers.host,req.url)}`);
        }
        return true;
	},
	get:function* (req,res){
		return yield new Promise((resolve)=>{
			let sid = getSid(req);
			let url = `${host}/api/session/${sid}`;
			let authObj = meituanBasicAuth(appkey,secret)(url)
		 	request({url: url, headers: authObj}, function (error, response, body) {
	          try {
	              let user = JSON.parse(body).data;
                  if(user.id) {
                      resolve(user);
                      (req.ctx&&req.ctx.cookies&&req.ctx.cookies.set("SID",sid));
                  }else {
                      resolve(false);
                  }
	          } catch (err) {
	            	resolve(false)
	          }
	        });
		})
	},
    out:function* (req,res){
        return yield new Promise((resolve)=>{
            let sid = getSid(req);
            let url = `${host}/api/logout/${sid}`;
            request({url: url}, function (error, response, body) {
                try {
                    let result = JSON.parse(body).data;
                    if(result == "ok"){
                        (req.ctx&&req.ctx.cookies&&req.ctx.cookies.set("SID",""));
                        resolve({
                            code:200
                        });
                    }else{
                        resolve({
                            code:500,
                            msg:"需要排除"
                        });
                    }
                } catch (err) {
                    resolve({
                        code:500,
                        msg:"需要排除"
                    })
                }
            });
        })
    }
}

module.exports = User;
