import Vue from 'vue'
import ColLabel from './components/ColLabel.vue'
import FormInput from './components/FormInput.vue'
import FormTextArea from './components/FormTextArea.vue'
import FormDate from './components/FormDate.vue'
import FormDateTime from './components/FormDateTime.vue'
import FormTime from './components/FormTime.vue'
import FormUpload from './components/FormUpload.vue'
import FormCheckBox from './components/FormCheckBox.vue'
import FormReadText from './components/FormReadText.vue'
import FormSelect from './components/FormSelect.vue'
import FormColor from './components/FormColor.vue'
import FormSwitch from './components/FormSwitch.vue'
import ComponentsSelect from './specialComponents/ComponentsSelect.vue'
import ComponentSelect from './specialComponents/ComponentSelect.vue'
import CityIdSelect from './specialComponents/CityIdSelect.vue'
import CityIdsSelect from './specialComponents/CityIdsSelect.vue'
import CreateItemId from './specialComponents/CreateItemId.vue'
import CouponId from './specialComponents/CouponId.vue'
Vue.component('render-cmp', {
  render: function (createElement) {
    var that = this
    return createElement(
      this.name,
      {
        props: {
          onChange: function (v) {
            that.onChange(v, that.objPath, that.keyStr)
          },
          tip: that.obj.description,
          label: that.obj.title,
          propsValue: that.obj.consequence,
          valueIsObj: that.obj.format == 'cityObjs' || that.obj.format == 'cityObj',
          required: that.required,
          breed: that.obj.breed,
          width: 360,
          optionList: that.obj.optionList
        }
      }
    )
  },
  data () {
    return {
      multiple: false
    }
  },
  computed: {
    name: function () {
      if (!this.obj) {
        return ''
      }
      if (this.obj.media && this.obj.media.type && this.obj.media.type.indexOf('image') > -1) {
        return 'formUpload'
      } else if (this.obj.format === 'date-time') {
        return 'formDateTime'
      } else if (this.obj.format === 'time') {
        return 'formTime'
      } else if (this.obj.format === 'color' || this.obj.type === 'color') {
        return 'formColor'
      } else if (this.obj.optionList && this.obj.optionList.length > 0) {
        return 'formSelect'
      } else if (this.obj.media && this.obj.media.type && this.obj.media.type.indexOf('text') > -1) {
        return 'formTextArea'
      } else if (this.obj.format === 'components') {
        // 组件单选多选拆分成两个组件   原因  使用同一个组件 从单选切换到多选  单选的值dom 已然存在
        return 'componentsSelect'
      } else if (this.obj.format === 'component') {
        return 'componentSelect'
      } else if (this.obj.format === 'cityIds' || this.obj.format === 'cityObjs') {
        return 'cityIdsSelect'
      } else if (this.obj.format === 'cityId' || this.obj.format === 'cityObj') {
        return 'cityIdSelect'
      } else if (this.obj.type === 'boolean') {
        return 'formSwitch'
      } else if (this.obj.format === 'tab') {
        return 'createItemId'
      } else if (this.obj.format === 'event') {
        return 'couponId'
      }
      return 'formInput'
    }
  },
  props: {
    obj: Object,
    onChange: Function,
    objPath: String,
    keyStr: String,
    required: Boolean
  },
  components: {
    colLabel: ColLabel,
    formInput: FormInput,
    formTextArea: FormTextArea,
    formDate: FormDate,
    formUpload: FormUpload,
    formCheckBox: FormCheckBox,
    formReadText: FormReadText,
    formTime: FormTime,
    formSelect: FormSelect,
    formSwitch: FormSwitch,
    formColor: FormColor,
    componentsSelect: ComponentsSelect,
    componentSelect: ComponentSelect,
    cityIdsSelect: CityIdsSelect,
    cityIdSelect: CityIdSelect,
    createItemId: CreateItemId,
    couponId: CouponId,
    formDateTime: FormDateTime
  }
})

