import Vue from 'vue'
import './RenderCmp.js'
// 注册组件FormList 实现formList的递归
import CmpTree from './pages/CmpTree.vue'
import FormTree from './pages/FormTree.vue'
Vue.component('cmp-tree', CmpTree)
Vue.component('form-tree', FormTree)
import ElementUI from 'element-ui'
import 'element-ui/lib/theme-default/index.css'
import './less/main.less'
Vue.use(ElementUI)

import PageDetail from './pages/PageDetail'
import store from './store/index.js'
import str from './webUtil/str'
import unoConfig from './webUtil/unoConfig'
module.exports = {
  createPage: function (page) {
    return new Promise(function(resolve, reject) {
      store.dispatch('savePage', {
        params: Object.assign({
          source:unoConfig.source,
          author:unoConfig.userInfo && unoConfig.userInfo.login,
          loginType:unoConfig.userInfo && unoConfig.userInfo.loginType
        },page),
        cb: (topicId) => {
          resolve(topicId)
        },
        err: (msg) => {
          reject(msg)
        }
      })
    })
  },
  init: function (businessKey,userInfo,env) {
    unoConfig.env = env
    unoConfig.userInfo = userInfo
    unoConfig.source = businessKey
  },
  render: function (node, uiOptions, page) {

    store.commit('setViewConfig', uiOptions.interface)

    store.commit('setPreviewConfig', uiOptions.preview)

    store.commit('setPageTopicId', page.topicId)

    store.commit('setPageDetail', page)

    store.commit('setPageConfig', str.decode(page.config))

    store.commit('setVersionConfig', str.decode(page.versionConfig))

    store.commit('setPagePlatform', page.platform)

    store.commit('setPageName', page.name)

    store.commit('setPublishStatus', page.publishStatus)

    store.commit('setNeedQueryPageDetail', false)

    store.dispatch('getEnums')

    Vue.component('page-detail', PageDetail)

    new Vue({
      store,
      el: node
    })

  },
  savePage: function (page) {
    return new Promise(function(resolve, reject) {
      store.dispatch('savePage', {
        params: page,
        cb: (topicId) => {
          resolve(topicId)
        },
        err: (msg) => {
          reject(msg)
        }
      })
    })
  },
  saveConfig: function () {
    return new Promise(function(resolve, reject) {
      var pageDetail = {
        topicId: store.state.page.topicId,
        config: JSON.stringify(store.state.page.config),
        versionConfig: JSON.stringify(store.state.page.versionConfig)
      }
      store.dispatch('savePage', {
        params: pageDetail,
        cb: (topicId) => {
          resolve(topicId)
        },
        err: (msg) => {
          reject(msg)
        }
      })
      var optList = JSON.parse(JSON.stringify(store.state.page.optList))
      if (optList && optList.length > 0) {
        store.commit('initOptList')
        store.dispatch('executeOptList', {
          params: optList,
          pageId: store.state.page.topicId
        })
      }
    })
  },
  publish: function () {
    return new Promise(function(resolve, reject) {
      var pageDetail = {
        topicId: store.state.page.topicId,
        config: JSON.stringify(store.state.page.config),
        versionConfig: JSON.stringify(store.state.page.versionConfig),
        publishStatus: 3,
        publishUser: unoConfig.userInfo.login
      }
      store.dispatch('savePage', {
        params: pageDetail,
        cb: (topicId) => {
          store.dispatch('publish', {
            params: {
              pageId: store.state.page.topicId,
              source: store.state.source
            },
            cb: () => {
              resolve()
            },
            err: (msg) => {
              reject(msg)
            }
          })
        },
        err: (msg) => {
          reject(msg)
        }
      })
      var optList = JSON.parse(JSON.stringify(store.state.page.optList))
      if (optList && optList.length > 0) {
        store.commit('initOptList')
        store.dispatch('executeOptList', {
          params: optList,
          pageId: store.state.page.topicId
        })
      }
    })
  },
  allVersions: function () {

  },
  rollback: function () {
    //todo 版本
  },
  checkStatus: function () {

  },
  offline: function () {
    return new Promise(function(resolve, reject) {
      var pageDetail = {
        topicId: store.state.page.topicId,
        onLine: 0,
        publishStatus: 3,
        publishUser: unoConfig.userInfo.login
      }
      store.dispatch('savePage', {
        params: pageDetail,
        cb: (topicId) => {
          store.dispatch('publish', {
            params: {
              pageId: store.state.page.topicId,
              source: store.state.source
            },
            cb: () => {
              resolve()
            },
            err: (msg) => {
              reject(msg)
            }
          })
        },
        err: (msg) => {
          reject(msg)
        }
      })
    })
  }
}
