/**
 * Created by shen on 2017/1/16.
 */
import Vuex from 'vuex'
import Vue from 'vue'
import enums from './enums.js'
import model from './model.js'
import page from './page.js'
import template from './template.js'
import request from '../webUtil/request'
Vue.use(Vuex)
var sourceMatchStr = location.search&&location.search.match(/source=([\S]+)[\&]?/)
module.exports = new Vuex.Store({
  modules: {
    enums: enums,
    model: model,
    page: page,
    template: template
  },
  state: {
    error: undefined,
    source: sourceMatchStr && sourceMatchStr[1]
  },
  mutations: {
    error (state, payload) {
      state.error = payload
    }
  },
  actions: {
    logout (context, payload) {
      request.logout(payload).then(json => {
        if (json && json.code === 200) {
          payload.cb && payload.cb()
        } else {
          context.commit('error', json && json.msg)
        }
      })
    }
  }
})
