/**
 * Created by shen on 2017/1/16.
 */
import request from '../webUtil/request'
import unoConfig from '../webUtil/unoConfig'
module.exports = {
  state: {
    'list': {},
    'showList': {}
  },
  mutations: {
    setModelList (state, payload) {
      state.list = payload
      state.showList = payload
    },
    filterModelList (state, payload) {
      if (!payload) {
        state.showList = JSON.parse(JSON.stringify(state.list))
      } else {
        var obj = {}
        var keys = Object.keys(state.showList) || []
        keys.forEach(key => {
          var modelList = state.showList[key]
          var filterList = modelList && modelList.filter(model => {
            if (model.cName.indexOf(payload) > -1) {
              return true
            }
            return false
          })
          obj[key] = JSON.parse(JSON.stringify(filterList))
        })
        state.showList = obj
      }
    }
  },
  actions: {
    getModelList (context) {
      request.getComMap({source:unoConfig.source}).then(json => {
        if (json && json.code === 200) {
          context.commit('setModelList', json && json.data)
        } else {
          context.commit('error', json && json.msg)
        }
      })
    }
  },
  getters: {}
}
