/**
 * Created by shen on 2017/1/16.
 */
import request from '../webUtil/request'
import {setPath, getPath} from 'deep-state'
import Vue from 'vue'
import ObjectFactory from './ObjectFactory'
import ConfigJSON from '../webUtil/ConfigJSON'
import str from '../webUtil/str'
module.exports = {
  state: {
    'viewConfig':{
      'head':true,
      'pageName':true,
      'cmpList':true,
      'position':true,
      'preview':true,
      'form':true
    },
    'previewConfig':{

    },
    'style':{
      "configTop":133,
      "modelSpan":3,
      "positionSpan":3,
      "previewSpan":6,
      "formSpan":12,
      "pageMinWidth":1180,
    },
    'needQueryPageDetail':true,
    'config': [],
    'configStr': '',
    'versionConfig': '',
    'versionConfigObj': {},
    'optList': [], // 纪录需要保存时执行的操作
    'cmpList': [],
    'pagePlatform': undefined,
    'topicId': undefined,
    'selectIndex': -1,
    'previewOrigin': null,
    'share': {},
    'query': {
      'name': undefined,
      'publishStatus': undefined,
      'status': undefined,
      'login': undefined
    },
    'pageList': [],
    'pageInfo': {
      'pageIndex': 1,
      'count': 0,
      'pageSize': 10
    },
    'pageDetail': {},
    'pageName': null,
    'publishStatus': null
  },
  mutations: {
    initOptList (state, payload) {
      state.optList = []
    },
    setPageDetail (state, payload) {
      state.pageDetail = Object.assign(ObjectFactory.emptyPageDetail(), payload)
      state.share = Object.assign(ObjectFactory.emptyShare(), JSON.parse(payload.share || '{}'))
    },
    setPreviewConfig (state, payload) {
      Vue.set(state, 'previewConfig', Object.assign(state.previewConfig,payload))
    },
    setNeedQueryPageDetail (state, payload) {
      state.needQueryPageDetail = payload
    },
    setViewConfig (state, payload) {
      Vue.set(state, 'viewConfig', Object.assign(state.viewConfig,payload))
      if(!state.viewConfig.head){
        state.style.configTop -= 83
      }
      if(!state.viewConfig.pageName){
        state.style.configTop -= 50
      }
      if(!state.viewConfig.cmpList){
        state.style.pageMinWidth -= 200
        state.style.positionSpan += state.style.modelSpan
      }
      if(!state.viewConfig.position){
        state.style.pageMinWidth -= 150
        state.style.previewSpan += state.style.positionSpan
      }
      if(!state.viewConfig.preview){
        state.style.pageMinWidth -= 420
        state.style.previewSpan += state.style.positionSpan
      }
      if(!state.viewConfig.form){
        state.style.pageMinWidth -= 410
        state.style.previewSpan += state.style.formSpan
      }
    },
    setPageTopicId (state, payload) {
      state.topicId = payload;
    },
    setPreviewOrigin(state, payload){
      state.previewOrigin = payload
    },
    setPageName (state, payload) {
      state.pageName = payload;
    },
    setPagePlatform (state, payload) {
      state.pagePlatform = payload
    },
    setCmpList (state, payload) {
      state.cmpList = payload ? payload.split(',') : []
    },
    setPageConfig (state, payload) {
      Vue.set(state, 'configStr', payload)
      var list = JSON.parse(payload || '[]')
      if (list && list.length > 0) {
        Vue.set(state, 'config', list)
        Vue.set(state, 'selectIndex', 0)
      } else {
        state.config = []
        state.selectIndex = -1
      }
    },
    setVersionConfig (state, payload) {
      Vue.set(state, 'versionConfig', payload)
      var obj = JSON.parse(payload || '{}')
      Vue.set(state, 'versionConfigObj', obj)
    },
    changeConfig (state, payload) {
      console.warn(payload)
      Vue.set(state.config[payload.objPath.split('.')[0]], 'showDefault', false)
      var obj = getPath(state.config, payload.objPath) || {}
      Vue.set(obj, payload.key, payload.value)
    },
    changeConfigDeleteList (state, payload) {
      var obj = getPath(state.config, `${payload.path}`) || {}
      obj.list.splice(payload.index, 1)
    },
    changeConfigAddList (state, payload) {
      var obj = getPath(state.config, `${payload.path}`) || {}
      var items = getPath(state.config, `${payload.path}.items`) || {}
      var newItems = JSON.parse(JSON.stringify(items))
      if (!obj.list || obj.list.length < 1) {
        Vue.set(obj, 'list', [newItems])
      } else {
        obj.list.splice(payload.index, 0, newItems)
      }
    },
    dragModel (state, payload) {
      let cmpIndex = parseInt(payload[0])
      let index = parseInt(payload[1])
      var obj = JSON.parse(JSON.stringify(state.config[cmpIndex]))
      var cmp = state.cmpList[cmpIndex]
      state.config.splice(cmpIndex, 1)
      state.config.splice(index, 0, obj)
      state.cmpList.splice(cmpIndex, 1)
      state.cmpList.splice(index, 0, cmp)
      state.selectIndex = parseInt(index)
    },
    moveUp (state, payload){
      let cmpIndex = parseInt(payload);
      var obj = JSON.parse(JSON.stringify(state.config[cmpIndex]))
      var cmp = state.cmpList[cmpIndex];
      var targetIndex = cmpIndex - 1 >= 0 ? cmpIndex - 1: 0;
      state.config.splice(cmpIndex, 1);
      state.config.splice(targetIndex, 0, obj)
      state.cmpList.splice(cmpIndex, 1)
      state.cmpList.splice(targetIndex, 0, cmp)
      state.selectIndex = parseInt(targetIndex)
    },
    moveDown (state, payload){
      let cmpIndex = parseInt(payload);
      var obj = JSON.parse(JSON.stringify(state.config[cmpIndex]))
      var cmp = state.cmpList[cmpIndex];
      var targetIndex = cmpIndex + 1 < state.cmpList.length ? cmpIndex + 1: state.cmpList.length - 1;
      state.config.splice(cmpIndex, 1);
      state.config.splice(targetIndex, 0, obj)
      state.cmpList.splice(cmpIndex, 1)
      state.cmpList.splice(targetIndex, 0, cmp)
      state.selectIndex = parseInt(targetIndex)
    },
    addModel (state, payload) {
      state.config.splice(++state.selectIndex, 0, payload.config)
      state.cmpList.splice(state.selectIndex, 0, payload.uniqueKey)
    },
    deleteModel (state, payload) {
      var optList = ConfigJSON.getOptListAboutDeleteList([state.config[payload]])
      optList = optList.concat(JSON.parse(JSON.stringify(state.optList)))
      console.warn(JSON.stringify(state.optList))
      Vue.set(state, 'optList', optList)
      console.warn('deleteModel')
      console.warn(JSON.stringify(optList))
      console.warn(JSON.stringify(state.optList))
      if (payload > -1 && payload < state.config.length) {
        if (payload === state.config.length - 1) {
          state.selectIndex = parseInt(payload) - 1
        } else {
          state.selectIndex = parseInt(payload)
        }
        state.config.splice(payload, 1)
        state.cmpList.splice(payload, 1)
      }
    },
    setSelectIndex (state, payload) {
      console.warn('setSelectIndex')
      console.warn(payload)
      state.selectIndex = payload
    },
    setPublishStatus (state, payload){
      state.publishStatus = payload;
    },
    newPage (state) {
      state.pageDetail = ObjectFactory.emptyPageDetail()
      state.share = ObjectFactory.emptyShare()
      state.config = []
    },
    setList (state, payload) {
      Vue.set(state, 'pageList', payload.pageList)
      Vue.set(state, 'pageInfo', payload.pageInfo)
    },
    deletePage (state, payload) {
      state.pageList.splice(payload, 1)
    },
    changePageValue (state, payload) {
      setPath(state, payload.path, payload.value)
    },
    updateConfigBox(state,data = {}){
        if(data.type == "remove"){
            var val = ConfigJSON.removeConfigBox(state.versionConfig,data.param);
            Vue.set(state, 'versionConfig', val)
            var obj = JSON.parse(val || '{}')
            Vue.set(state, 'versionConfigObj', obj)
        }
    }
  },
  actions: {
    getPageConfig (context, payload) {
      request.getPageConfigByTopicId(payload).then(json => {
        if (json && json.code === 200) {
          context.commit('setPageConfig', str.decode(json && json.data && json.data.config))
          context.commit('setVersionConfig', str.decode(json && json.data && json.data.versionConfig))
          context.commit('setCmpList', json && json.data && json.data.cmpListStr)
          context.commit('setPagePlatform', json && json.data && json.data.platform)
          context.commit('setPageTopicId', json && json.data && json.data.topicId)
          context.commit('setPageName', json && json.data && json.data.name)
          context.commit('setPublishStatus', json && json.data && json.data.publishStatus)
          context.commit('setPreviewOrigin',json && json.data && json.data.previewOrigin)
        } else {
          context.commit('error', json && json.msg)
        }
      })
    },
    getPageList (context, payload) {
      request.getPageList(payload).then(json => {
        if (json && json.code === 200) {
          context.commit('setList', json && json.data)
        } else {
          context.commit('error', json && json.msg)
        }
      })
    },
    clearPageList (context, payload){
      context.commit('setList', {
        pageInfo: context.state.pageInfo,
        pageList: []
      })
    },
    savePage (context, payload) {
      if(payload.params.config) {
        payload.params.config = str.encode(payload.params.config)
      }
      request.savePage(payload.params).then(json => {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json.data)
        } else {
          payload.err && payload.err(json && json.msg)
          context.commit('error', json && json.msg)
        }
      })
    },
    deletePage (context, payload) {
      var params = {
        id: payload.page.id
      }
      request.deletePage(params).then(json => {
        if (json && json.code === 200) {
          context.commit('deletePage', payload.pageIndex)
          payload.cb && payload.cb()
        } else {
          payload.errorCb && payload.errorCb()
          context.commit('error', json && json.msg)
        }
      })
    },
    createItemId (context, payload) {
      request.createItemId(payload.params).then(json => {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json.data)
        } else {
          context.commit('error', json && json.msg)
        }
      })
    },
    savePageItemIdMap (context, payload) {
      request.savePageItemIdMap(payload.params).then(json => {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json.data)
        } else {
          context.commit('error', json && json.msg)
        }
      })
    },
    publish (context, payload) {
      request.publish(payload.params).then(json => {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json)
        } else {
          context.commit('error', json && json.msg)
        }
      })
    },
    copyPage (context, payload) {
      request.copyPage(payload.params).then(json => {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json)
        } else {
          context.commit('error', json && json.msg)
        }
      })
    },
    sendMessage (context, payload) {
      request.sendMessage(payload.params).then(json => {
        if (json && json.code === 200) {
          payload.cb && payload.cb(json)
        } else {
          context.commit('error', json && json.msg)
        }
      })
    },
    executeOptList (context, payload) {
      var optList = payload.params
      if (optList && optList.length > 0) {
        var deleteItemOpts = optList.filter(item => {
          if (item.type === 'deleteItemId') {
            return true
          }
          return false
        })
        var itemIds = deleteItemOpts.map(item => {
          return item.data
        })
        var params = {
          itemIds: itemIds && itemIds.toString(),
          pageId: payload.pageId
        }
        console.warn('deleteItemIds')
        console.warn(JSON.stringify(params))
        request.deleteItemIds(params).then(json => {
          if (json && json.code === 200) {
            payload.cb && payload.cb(json)
          } else {
            context.commit('error', json && json.msg)
          }
        })
      }
    }
  },
  getters: {
  }
}
